<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/photos/library/v1/photos_library.proto

namespace Google\Photos\Library\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request to retrieve the user's list of shared albums. This will return the
 * list of albums corresponding to the user's 'Sharing' tab in the Google Photos
 * app.
 *
 * Generated from protobuf message <code>google.photos.library.v1.ListSharedAlbumsRequest</code>
 */
class ListSharedAlbumsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Maximum number of albums to return in the response. The default number of
     * albums to return at a time is 20. The maximum `pageSize` is 50.
     *
     * Generated from protobuf field <code>int32 page_size = 1;</code>
     */
    private $page_size = 0;
    /**
     * A continuation token to get the next page of the results. Adding this to
     * the request returns the rows after the `pageToken`. The `pageToken` should
     * be the value returned in the `nextPageToken` parameter in the response to
     * the `listSharedAlbums` request.
     *
     * Generated from protobuf field <code>string page_token = 2;</code>
     */
    private $page_token = '';
    /**
     * If set, the results exclude media items that were not created by this app.
     * Defaults to false (all albums are returned). This field is ignored if the
     * photoslibrary.readonly.appcreateddata scope is used.
     *
     * Generated from protobuf field <code>bool exclude_non_app_created_data = 3;</code>
     */
    private $exclude_non_app_created_data = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int $page_size
     *           Maximum number of albums to return in the response. The default number of
     *           albums to return at a time is 20. The maximum `pageSize` is 50.
     *     @type string $page_token
     *           A continuation token to get the next page of the results. Adding this to
     *           the request returns the rows after the `pageToken`. The `pageToken` should
     *           be the value returned in the `nextPageToken` parameter in the response to
     *           the `listSharedAlbums` request.
     *     @type bool $exclude_non_app_created_data
     *           If set, the results exclude media items that were not created by this app.
     *           Defaults to false (all albums are returned). This field is ignored if the
     *           photoslibrary.readonly.appcreateddata scope is used.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Photos\Library\V1\PhotosLibrary::initOnce();
        parent::__construct($data);
    }

    /**
     * Maximum number of albums to return in the response. The default number of
     * albums to return at a time is 20. The maximum `pageSize` is 50.
     *
     * Generated from protobuf field <code>int32 page_size = 1;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * Maximum number of albums to return in the response. The default number of
     * albums to return at a time is 20. The maximum `pageSize` is 50.
     *
     * Generated from protobuf field <code>int32 page_size = 1;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * A continuation token to get the next page of the results. Adding this to
     * the request returns the rows after the `pageToken`. The `pageToken` should
     * be the value returned in the `nextPageToken` parameter in the response to
     * the `listSharedAlbums` request.
     *
     * Generated from protobuf field <code>string page_token = 2;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * A continuation token to get the next page of the results. Adding this to
     * the request returns the rows after the `pageToken`. The `pageToken` should
     * be the value returned in the `nextPageToken` parameter in the response to
     * the `listSharedAlbums` request.
     *
     * Generated from protobuf field <code>string page_token = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * If set, the results exclude media items that were not created by this app.
     * Defaults to false (all albums are returned). This field is ignored if the
     * photoslibrary.readonly.appcreateddata scope is used.
     *
     * Generated from protobuf field <code>bool exclude_non_app_created_data = 3;</code>
     * @return bool
     */
    public function getExcludeNonAppCreatedData()
    {
        return $this->exclude_non_app_created_data;
    }

    /**
     * If set, the results exclude media items that were not created by this app.
     * Defaults to false (all albums are returned). This field is ignored if the
     * photoslibrary.readonly.appcreateddata scope is used.
     *
     * Generated from protobuf field <code>bool exclude_non_app_created_data = 3;</code>
     * @param bool $var
     * @return $this
     */
    public function setExcludeNonAppCreatedData($var)
    {
        GPBUtil::checkBool($var);
        $this->exclude_non_app_created_data = $var;

        return $this;
    }

}

