<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/photos/types/album.proto

namespace Google\Photos\Types;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Information about albums that are shared. This information is only included
 * if you created the album, it is shared and you have the sharing scope.
 *
 * Generated from protobuf message <code>google.photos.types.ShareInfo</code>
 */
class ShareInfo extends \Google\Protobuf\Internal\Message
{
    /**
     * Options that control the sharing of an album.
     *
     * Generated from protobuf field <code>.google.photos.types.SharedAlbumOptions shared_album_options = 1;</code>
     */
    private $shared_album_options = null;
    /**
     * A link to the album that's now shared on the Google Photos website and app.
     * Anyone with the link can access this shared album and see all of the items
     * present in the album.
     *
     * Generated from protobuf field <code>string shareable_url = 2;</code>
     */
    private $shareable_url = '';
    /**
     * A token that can be used by other users to join this shared album via the
     * API.
     *
     * Generated from protobuf field <code>string share_token = 3;</code>
     */
    private $share_token = '';
    /**
     * True if the user has joined the album. This is always true for the owner
     * of the shared album.
     *
     * Generated from protobuf field <code>bool is_joined = 4;</code>
     */
    private $is_joined = false;
    /**
     * True if the user owns the album.
     *
     * Generated from protobuf field <code>bool is_owned = 5;</code>
     */
    private $is_owned = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Photos\Types\SharedAlbumOptions $shared_album_options
     *           Options that control the sharing of an album.
     *     @type string $shareable_url
     *           A link to the album that's now shared on the Google Photos website and app.
     *           Anyone with the link can access this shared album and see all of the items
     *           present in the album.
     *     @type string $share_token
     *           A token that can be used by other users to join this shared album via the
     *           API.
     *     @type bool $is_joined
     *           True if the user has joined the album. This is always true for the owner
     *           of the shared album.
     *     @type bool $is_owned
     *           True if the user owns the album.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Photos\Types\Album::initOnce();
        parent::__construct($data);
    }

    /**
     * Options that control the sharing of an album.
     *
     * Generated from protobuf field <code>.google.photos.types.SharedAlbumOptions shared_album_options = 1;</code>
     * @return \Google\Photos\Types\SharedAlbumOptions
     */
    public function getSharedAlbumOptions()
    {
        return $this->shared_album_options;
    }

    /**
     * Options that control the sharing of an album.
     *
     * Generated from protobuf field <code>.google.photos.types.SharedAlbumOptions shared_album_options = 1;</code>
     * @param \Google\Photos\Types\SharedAlbumOptions $var
     * @return $this
     */
    public function setSharedAlbumOptions($var)
    {
        GPBUtil::checkMessage($var, \Google\Photos\Types\SharedAlbumOptions::class);
        $this->shared_album_options = $var;

        return $this;
    }

    /**
     * A link to the album that's now shared on the Google Photos website and app.
     * Anyone with the link can access this shared album and see all of the items
     * present in the album.
     *
     * Generated from protobuf field <code>string shareable_url = 2;</code>
     * @return string
     */
    public function getShareableUrl()
    {
        return $this->shareable_url;
    }

    /**
     * A link to the album that's now shared on the Google Photos website and app.
     * Anyone with the link can access this shared album and see all of the items
     * present in the album.
     *
     * Generated from protobuf field <code>string shareable_url = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setShareableUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->shareable_url = $var;

        return $this;
    }

    /**
     * A token that can be used by other users to join this shared album via the
     * API.
     *
     * Generated from protobuf field <code>string share_token = 3;</code>
     * @return string
     */
    public function getShareToken()
    {
        return $this->share_token;
    }

    /**
     * A token that can be used by other users to join this shared album via the
     * API.
     *
     * Generated from protobuf field <code>string share_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setShareToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->share_token = $var;

        return $this;
    }

    /**
     * True if the user has joined the album. This is always true for the owner
     * of the shared album.
     *
     * Generated from protobuf field <code>bool is_joined = 4;</code>
     * @return bool
     */
    public function getIsJoined()
    {
        return $this->is_joined;
    }

    /**
     * True if the user has joined the album. This is always true for the owner
     * of the shared album.
     *
     * Generated from protobuf field <code>bool is_joined = 4;</code>
     * @param bool $var
     * @return $this
     */
    public function setIsJoined($var)
    {
        GPBUtil::checkBool($var);
        $this->is_joined = $var;

        return $this;
    }

    /**
     * True if the user owns the album.
     *
     * Generated from protobuf field <code>bool is_owned = 5;</code>
     * @return bool
     */
    public function getIsOwned()
    {
        return $this->is_owned;
    }

    /**
     * True if the user owns the album.
     *
     * Generated from protobuf field <code>bool is_owned = 5;</code>
     * @param bool $var
     * @return $this
     */
    public function setIsOwned($var)
    {
        GPBUtil::checkBool($var);
        $this->is_owned = $var;

        return $this;
    }

}

